diff --git a/libavcodec/alpha/Makefile b/libavcodec/alpha/Makefile
index e55fe49..cdfd1c8 100644
--- a/libavcodec/alpha/Makefile
+++ b/libavcodec/alpha/Makefile
@@ -4,3 +4,4 @@ OBJS += alpha/dsputil_alpha.o                                           \
         alpha/motion_est_mvi_asm.o                                      \
         alpha/mpegvideo_alpha.o                                         \
         alpha/simple_idct_alpha.o                                       \
+
diff --git a/libavcodec/arm/Makefile b/libavcodec/arm/Makefile
index 8b96232..74d6a14 100644
--- a/libavcodec/arm/Makefile
+++ b/libavcodec/arm/Makefile
@@ -88,3 +88,4 @@ NEON-OBJS                              += arm/dsputil_init_neon.o       \
                                           arm/int_neon.o                \
                                           arm/mpegvideo_neon.o          \
                                           arm/simple_idct_neon.o        \
+
diff --git a/libavcodec/bfin/Makefile b/libavcodec/bfin/Makefile
index 6b3e7cf..c7d9ac1 100644
--- a/libavcodec/bfin/Makefile
+++ b/libavcodec/bfin/Makefile
@@ -5,3 +5,4 @@ OBJS += bfin/dsputil_bfin.o                                             \
         bfin/pixels_bfin.o                                              \
         bfin/vp3_bfin.o                                                 \
         bfin/vp3_idct_bfin.o                                            \
+
diff --git a/libavcodec/mips/Makefile b/libavcodec/mips/Makefile
index 37899b1..4cb3c16 100644
--- a/libavcodec/mips/Makefile
+++ b/libavcodec/mips/Makefile
@@ -1,3 +1,4 @@
 MMI-OBJS += mips/dsputil_mmi.o                                          \
             mips/idct_mmi.o                                             \
             mips/mpegvideo_mmi.o                                        \
+
diff --git a/libavcodec/ppc/Makefile b/libavcodec/ppc/Makefile
index 31f4fb8..ca60310 100644
--- a/libavcodec/ppc/Makefile
+++ b/libavcodec/ppc/Makefile
@@ -19,3 +19,4 @@ ALTIVEC-OBJS                           += ppc/dsputil_altivec.o         \
                                           ppc/idct_altivec.o            \
                                           ppc/int_altivec.o             \
                                           ppc/mpegvideo_altivec.o       \
+
diff --git a/libavcodec/sh4/Makefile b/libavcodec/sh4/Makefile
index aa17eab..209f190 100644
--- a/libavcodec/sh4/Makefile
+++ b/libavcodec/sh4/Makefile
@@ -1,3 +1,4 @@
 OBJS += sh4/dsputil_align.o                                             \
         sh4/dsputil_sh4.o                                               \
         sh4/idct_sh4.o                                                  \
+
diff --git a/libavcodec/sparc/Makefile b/libavcodec/sparc/Makefile
index 1b6ac81..174908d 100644
--- a/libavcodec/sparc/Makefile
+++ b/libavcodec/sparc/Makefile
@@ -1,2 +1,3 @@
 VIS-OBJS += sparc/dsputil_vis.o                                         \
             sparc/simple_idct_vis.o                                     \
+
diff --git a/libavcodec/x86/Makefile b/libavcodec/x86/Makefile
index f633cf6..c1c83f5 100644
--- a/libavcodec/x86/Makefile
+++ b/libavcodec/x86/Makefile
@@ -77,3 +77,4 @@ YASM-OBJS-$(CONFIG_VP8_DECODER)        += x86/vp8dsp.o
 YASM-OBJS                              += x86/dsputil_yasm.o            \
                                           x86/deinterlace.o             \
                                           x86/fmtconvert.o              \
+
diff --git a/libavutil/ppc/Makefile b/libavutil/ppc/Makefile
index 5b18b08..5efd9d9 100644
--- a/libavutil/ppc/Makefile
+++ b/libavutil/ppc/Makefile
@@ -1 +1,2 @@
 OBJS += ppc/cpu.o                                                       \
+
diff --git a/libavutil/x86/Makefile b/libavutil/x86/Makefile
index de8a341..685a1f2 100644
--- a/libavutil/x86/Makefile
+++ b/libavutil/x86/Makefile
@@ -1 +1,2 @@
 OBJS += x86/cpu.o                                                       \
+
diff --git a/libswscale/bfin/Makefile b/libswscale/bfin/Makefile
index 5f34550..acfdff3 100644
--- a/libswscale/bfin/Makefile
+++ b/libswscale/bfin/Makefile
@@ -1,3 +1,4 @@
 OBJS +=  bfin/internal_bfin.o                                           \
          bfin/swscale_bfin.o                                            \
          bfin/yuv2rgb_bfin.o                                            \
+
diff --git a/libswscale/ppc/Makefile b/libswscale/ppc/Makefile
index 018955b..83cfcf0 100644
--- a/libswscale/ppc/Makefile
+++ b/libswscale/ppc/Makefile
@@ -1,3 +1,4 @@
 ALTIVEC-OBJS +=  ppc/swscale_altivec.o                                  \
                  ppc/yuv2rgb_altivec.o                                  \
                  ppc/yuv2yuv_altivec.o                                  \
+
diff --git a/libswscale/sparc/Makefile b/libswscale/sparc/Makefile
index 2351ba4..a2fa556 100644
--- a/libswscale/sparc/Makefile
+++ b/libswscale/sparc/Makefile
@@ -1 +1,2 @@
 VIS-OBJS += sparc/yuv2rgb_vis.o                                         \
+
diff --git a/libswscale/x86/Makefile b/libswscale/x86/Makefile
index 68d5381..8fd1512 100644
--- a/libswscale/x86/Makefile
+++ b/libswscale/x86/Makefile
@@ -9,3 +9,4 @@ MMX-OBJS                        += x86/rgb2rgb.o                        \
 YASM-OBJS                       += x86/input.o                          \
                                    x86/output.o                         \
                                    x86/scale.o                          \
+